//-----------------------------------------------------------------------
// Code to draw the FNIRSI 1013-D fonts on a html canvas
//-----------------------------------------------------------------------
function font_2_print(canvas)
{
  var ctx = canvas.getContext("2d");

  var ww = window.innerWidth - 26;
  var wh = window.innerHeight - 26;

  if(ww < 1200)
    scaler = ww / 1200;
  else
    scaler = 1;
  
  if((600 * scaler) > wh)
    scaler = wh / 600;

  //Make the canvas fit the window
  canvas.width = parseInt(1200 * scaler);
  canvas.height = parseInt(600 * scaler);

  //All items are drawn with fixed big scale design size and are scaled with the overal canvas scale function
  ctx.scale(scaler,scaler);

  //#58A094 screen color? Philips scope
  //#B4FFFE line color?

  //#2B7D4E Van mijn software scope.
  var i,x,y;

  ctx.save();

  //Draw the background color
  ctx.fillStyle = "#202020";
  ctx.fillRect(0,0,1200,600);

  //Set the text color
  ctx.fillStyle = "#B4FFFE";

  x = 20;
  y = 20;
  
  for(i=0x20;i<0x7F;i++)
  {
    x += drawcharacter(ctx, x, y, i, font_2);
    
    if(x > 1170)
    {
      x = 20;
      y += font_2[1];
    }
  }

  x = 20;
  y += font_2[1] + 20;
  
  for(i=0x20;i<0xFF;i++)
  {
    x += drawcharacter(ctx, x, y, i, font_3);
    
    if(x > 1170)
    {
      x = 20;
      y += font_3[1];
    }
  }

  x = 20;
  y += font_3[1] + 20;
  
  for(i=0x20;i<0x7F;i++)
  {
    x += drawcharacter(ctx, x, y, i, font_4);
    
    if(x > 1170)
    {
      x = 20;
      y += font_4[1];
    }
  }

  x = 20;
  y += font_4[1] + 20;
  
  for(i=0x20;i<0xFF;i++)
  {
    x += drawcharacter(ctx, x, y, i, font_5);
    
    if(x > 1170)
    {
      x = 20;
      y += font_5[1];
    }
  }

  x = 20;
  y += font_5[1] + 20;
  
  for(i=0x20;i<0xFF;i++)
  {
    x += drawcharacter(ctx, x, y, i, font_6);
    
    if(x > 1170)
    {
      x = 20;
      y += font_6[1];
    }
  }

  x = 20;
  y += font_6[1] + 20;
  
  for(i=0x20;i<0xFF;i++)
  {
    x += drawcharacter(ctx, x, y, i, font_7);
    
    if(x > 1170)
    {
      x = 20;
      y += font_7[1];
    }
  }
  
  //Draw the outer edge
  ctx.lineWidth = 4;
  ctx.strokeStyle = "#000000";
  ctx.strokeRect(0,0,1200,600);


  ctx.restore();
}

//-----------------------------------------------------------

function drawcharacter(ctx, xpos, ypos, char, font)
{
  var info = checkcharinfont(char, font[4]);

  //Check if character is valid
  if(info === 0)
    return(0);

  //Get the index in the metrics and pixel arrays
  var idx = char - info[0];
  
  //Get the number of lines in the font
  var lines = font[0];
  
  //Get the metrics for this character
  var metrics = info[2][idx];
  
  //Get the pixel data for this character
  var data = info[3][idx];
  
  //Get the metrics info
  var pixels = metrics[0];
  var bytes =  metrics[2];
  
  
  var pixel;
  var line;
  var col;
  var x;
  
  for(line=0;line<lines;line++)
  {
    x = xpos;
    idx = line * bytes;
    col = data[idx];
    
    for(pixel=0;pixel<pixels;)
    {
      //Select the pixel to check
      col = col << 1;
      
      //Check if pixel is set and print it if so
      if(col & 0x100)
        ctx.fillRect(x, ypos, 1, 1);
      
      pixel++;
      x++;
      
      //Check pixel on multiple of 8 for next byte select
      if((pixel % 8) === 0)
      {
        idx++;
        col = data[idx];
      }
    }
    
    //Point to next yposition
    ypos++;
  }
  
  return(metrics[1]);
}

function checkcharinfont(char, info)
{
  //Check if the character is below the first character in this info set
  if((char >= info[0]) && (char <= info[1]))
  {
    //If so signal character found
    return(info);
  }
  
  //Else check if there is no more font info
  if(info[4] === 0)
  {
    //If not signal not a valid character
    return(0);
  }
  
  //Else go and check the next info set
  return(checkcharinfont(char, info[4]));
}